import { ObjectLiteral } from 'typeorm';
import { GetDataloaderInput } from './types';
import DataLoader from 'dataloader';
/**
 * Wrapper class for Dataloader.
 */
export declare class BaseDataLoader<V extends ObjectLiteral, K = string> {
    private dataloader;
    private valueRepo;
    private type;
    private resolveInput?;
    private fieldName;
    private resultType?;
    constructor(inp: GetDataloaderInput<V>);
    getBatchLoadFunction(): (keys: readonly K[]) => Promise<V[] | V[][]>;
    private getValuesFromKeys;
    private getFieldCountObject;
    getDataLoader(): DataLoader<K, V, K> | DataLoader<K, V[], K>;
}
