import { FindManyOptions, ObjectLiteral, EntityTarget } from 'typeorm';

export type ResolveType = 'one' | 'many' | 'many-to-many';
export type ResultType = 'entity' | 'count';
//TODO: make this type comply with that of paramter of Repository.find().
// The `where` field of the FindConditions support string type also, which is not supported here currently
//TODO: Narrow the type of function that can be passed. (keys:K[])=>Promise<V[]>
export type ResolveInput<Entity> =
  | Function
  | FindManyOptions<Entity>
  | ObjectLiteral;
export type InjectLoaderInput<V> = EntityTarget<V> | ObjectInput<V>;

export type ObjectInput<V> = Omit<GetDataloaderInput<V>, 'dataloaderName'>;
export interface GetDataloaderInput<Entity> {
  dataloaderName: string;
  fromEntity: EntityTarget<Entity>;
  resolveType?: ResolveType;
  fieldName?: string;
  resolveInput?: ResolveInput<Entity>;
  resultType?: ResultType;
}
